augroup UserStatusline
  autocmd!
  autocmd BufEnter,WinEnter,TermOpen * setlocal statusline=%!ActiveStatus()
  autocmd WinLeave * setlocal statusline=%!PassiveStatus()
augroup END

hi User1 guifg=DarkRed guibg=Black
hi User2 guifg=White guibg=Black
hi User3 guifg=Cyan guibg=Black
hi User4 guifg=Orange guibg=Black
hi User5 guifg=Red guibg=Black
hi User6 guifg=Gray guibg=Black
hi User7 guifg=Gray guibg=Black
hi User8 guifg=DarkYellow guibg=Black

" https://nest.pijul.com/tae/setup:master/
function! GetCursorPosition()
  if &buftype == ''
    let l:position = getcurpos()
    return l:position[1] . 'Ⲷ ' . l:position[2] . 'Ⲽ'
  endif

  return &buftype ==# 'quickfix'
	\ ? line('.') . '/' . line('$')
	\ : ''
endfunction

" Taken from gitgutter README
function! GitHunkStatus()
  let [a,m,r] = GitGutterGetHunkSummary()
  return printf('+%d ~%d -%d', a, m, r)
endfunction

function! ActiveStatus() abort
  let statusline=""
  let statusline.="%1*\ %{winnr()}\ "
  let statusline.="%4*\ %{GitHunkStatus()}"
  let statusline.="%2*\ %Y\ "
  let statusline.="%3*%<%f"
  let statusline.="%="
  let statusline.="%4*\ %{GetCursorPosition()}\ (%3p%%)"
  return statusline
endfunction

function! PassiveStatus() abort
  let statusline=""
  let statusline.="%5*\ %{winnr()}\ "
  let statusline.="%8*\ %{GitHunkStatus()}"
  let statusline.="%6*\ %Y\ "
  let statusline.="%7*%<%f"
  let statusline.="%="
  let statusline.="%8*\ %{GetCursorPosition()}\ (%3p%%)"
  return statusline
endfunction

set statusline=%!ActiveStatus()
